clear all

cd "C:\Users\Toshiba\Dropbox\Redoublement"

sysdir set PERSONAL "C:\Users\Toshiba\Dropbox\Redoublement\ado\personal"
sysdir set PLUS "C:\Users\Toshiba\Dropbox\Redoublement\ado\plus"
set mem 800m

use panel95c ,replace

set more off

keep ident mathel_std franel_std femme dipm dipm1-dipm6 cspp cspp1-cspp7 age6e rang2 rang3 rang4etplus nbenf3 nbenf4etplus /*
*/ mere_et pere_et prim_priv pass1 pass2 pass3 pass4 general grade9_fra_std grade9_mat_std redoub_prim repet /*
*/ ned1 ned1_th tuetab1 tuetab11-tuetab19 secteur1 net1_tr net1_tr1-net1_tr4 effectif_grade_1 eff_etab_t1 lv11_all lv11_ang lv11_othe  inzep1  /*
*/ ned2 ned2_th ned2_th_c tuetab2 tuetab21-tuetab29  secteur2 net2_tr net2_tr1-net2_tr4 effectif_grade_2 eff_etab_t2 lv12_all lv12_ang lv12_othe  inzep2   /*
*/ ned3 ned3_th ned3_th_c ned3_th_cr tuetab3 tuetab31-tuetab39  secteur3 net3_tr net3_tr1-net3_tr4 effectif_grade_3 eff_etab_t3_c eff_etab_t3 lv13_all lv13_ang lv13_othe  inzep3  /*
*/ ned4 ned4_th ned4_th_c ned4_th_cr tuetab4 tuetab41-tuetab49 secteur4 net4_tr net4_tr1-net4_tr4 effectif_grade_4 effectif_grade_4_c eff_etab_t4 eff_etab_t4_c lv14_all lv14_ang lv14_othe  inzep4  /*
*/ ned5 ned5_th ned5_th_c ned5_th_cr tuetab5 tuetab51-tuetab59 secteur5 net5_tr net5_tr1-net5_tr4 effectif_grade_5 effectif_grade_5_c eff_etab_t5 eff_etab_t5_c lv15_all lv15_ang lv15_othe  inzep5  /*
*/ voie1234 voie11234 voie12234 voie12334 voie123V voie12V voie11V voie122V voie1233V voie1223V voie1123V voie112V

foreach i of varlist mathel_std franel_std  /*
*/ ned1 ned1_th tuetab1 secteur1 net1_tr eff_etab_t1 lv11_all lv11_othe inzep1 {

drop if missing(`i')
}

foreach i of varlist /*
*/ ned2 ned2_th tuetab2 secteur2 net2_tr eff_etab_t2 lv12_all lv12_othe inzep2  /*
*/ ned3 ned3_th tuetab3 secteur3 net3_tr eff_etab_t3 lv13_all lv13_othe inzep3  /*
*/ ned4 ned4_th tuetab4 secteur4 net4_tr eff_etab_t4 lv14_all lv14_othe inzep4  {

drop if missing(`i') & repet<2
}

foreach i of varlist voie1234 voie11234 voie12234 voie12334 voie123V voie12V voie11V voie122V voie1233V voie1223V voie1123V voie112V {
tab `i'
}

save BDD_2012,replace

recode grade9_fra_std .=-1
recode grade9_mat_std .=-1
recode pass3 .=-1
recode pass4 .=-1
recode effectif_grade_5 .=0
recode eff_etab_t5 .=0
recode effectif_grade_4 .=0
recode eff_etab_t4 .=0

replace pass3=. if pass3==-1
replace pass4=. if pass4==-1

scalar p1=0.18
scalar p2=0.29
scalar p3=0.30
scalar p4=1-p1-p2-p3
*scalar p5=1-p1-p2-p3-p4


save BDD_2012,replace

scalar theta1=40
while theta1 > 35.5	{
use BDD_2012,replace

scalar size=_N
/*Initialisation of weights */

save BDD_2012b,replace

forvalues i =1/2 {
append using BDD_2012b
save BDD_2012b,replace
}

bysort ident : gen group_cat=_n

scalar k1=-1+2*runiform()
scalar k2=-1+2*runiform()
scalar k3=-1+2*runiform()
scalar p1=1/(1+exp(k1)+exp(k2)+exp(k3))
scalar p2=exp(k1)/(1+exp(k1)+exp(k2)+exp(k3))
scalar p3=exp(k2)/(1+exp(k1)+exp(k2)+exp(k3))
scalar p4=exp(k3)/(1+exp(k1)+exp(k2)+exp(k3))

gen prob1=p1
replace prob1=p2 if group_cat==2
replace prob1=p3 if group_cat==3
replace prob1=p4 if group_cat==4


  /*************/
 /*  STEP 0   */
/*************/

char cspp[omit] 5
char dipm[omit] 1
char inzep1[omit] 2
char inzep2[omit] 2
char inzep3[omit] 2
char inzep4[omit] 2
char inzep5[omit] 2
xi : reg mathel_std i.group_cat ,nocons
predict resm,res
su resm 
scalar sigma_resm=r(sd)

xi : reg franel_std  i.group_cat,nocons
predict resf,res
su resf
scalar sigma_resf=r(sd)

xi : reg ned1 i.tuetab1 i.secteur1 effectif_grade_1 eff_etab_t1 lv11_all lv11_othe inzep1 /*
*/pere_et prim_priv i.group_cat , nocons
predict resn1,res
su resn1
scalar sigma_resn1=r(sd)

gen vrais_indiv=normalden(resn1,0,sigma_resn1)*normalden(resf,0,sigma_resf)*normalden(resm,0,sigma_resm)

/* Build the individual weight */

gen weight_vrais=prob1*vrais_indiv
bysort ident : egen weight_sum=total(weight_vrais)

gen prob_indiv=prob1*vrais_indiv/weight_sum

drop resn1 vrais_indiv weight_sum weight_vrais 

scalar drop sigma_resn1

/* Iterations until convergence */

gen prob2=prob1
gen prob_indiv2=prob_indiv

set more off
local crit=1
local iter=1
local llk=0

di "Program started on $S_DATE at $S_TIME" 
while `iter'<1000 & `crit'>0.00001 {

quietly{

run Model55.do


gen vrais_indiv=normalden(resm0,0,sigma_resm0)*normalden(resf0,0,sigma_resf0)*normalden(resn1,0,sigma_resn1) /*
*/ *P1^pass1*(1-P1)^(1-pass1) /*
*/ *normalden(resn2,0,sigma_resn2)^(pass1==1)*normalden(resn2r,0,sigma_resn2r)^(pass1==0) /*
*/ *(P20^(pass2==0)*P21^(pass2==1)*P22^(pass2==2))^(pass1==1)*((1-P2r)^(pass2==0)*P2r^(pass2==2))^(pass1==0)  /*
*/ *normalden(resn3,0,sigma_resn3)^(pass2==2 & pass1==1)*normalden(resn3r,0,sigma_resn3r)^((pass2==2 & pass1==0) |(pass2==1 & pass1==1) ) /*
*/ *(P30^(pass3==0)*P31^(pass3==1)*P32^(pass3==2))^(pass2==2 & pass1==1)*((1-P3r)^(pass3==0)*P3r^(pass3==2))^((pass2==2 & pass1==0) |(pass2==1 & pass1==1) ) /*
*/ *normalden(resn4,0,sigma_resn4)^(repet==0)*normalden(resn4r,0,sigma_resn4r)^(repet==1) /*
*/ *P4^(pass4==1)*(1-P4)^(pass4==0) /*
*/ *normalden(resn5,0,sigma_resn5)^(repet==1) /*                            
*/ *normalden(resbrevm_pass,0,sigma_resbrevm_pass)^(repet==0)*normalden(resbrevm_passpas,0,sigma_resbrevm_passpas)^(repet==1) /*
*/ *normalden(resbrevf_pass,0,sigma_resbrevf_pass)^(repet==0)*normalden(resbrevf_passpas,0,sigma_resbrevf_passpas)^(repet==1) 


/* Build the individual weight */

gen weight_vrais=prob1*vrais_indiv
bysort ident : egen weight_sum=total(weight_vrais)

gen weight_indiv_prim=prob1*vrais_indiv/weight_sum

/* New type weights using constraints */

bysort group_cat : egen prob_prim=mean(weight_indiv_prim)

/*Calcul de la vraisemblance total*/
gen a=log(weight_sum)/4

gen vrais=sum(a)
su vrais
local llk=r(mean)

gen diff= (prob1-prob_prim)^2 

egen diff_sum_square=sum(diff)

sum diff_sum_square

local crit=r(mean)
local iter=`iter'+1

/* Actualisation of weight */


drop prob1 prob_indiv 
rename prob_prim prob1
rename weight_indiv_prim prob_indiv

drop resm0 resf0 resm02 resf02 resn1 resn12 resn22 resn2 resn3 resn32 resn4 resn42 resn5 resn52 /*
*/ resn22r resn2r resn3r resn32r resn4r resn42r resn5 resn52 P1 P4 P20 P21 P22 P30 P31 P32 P2r P3r  /*
*/ resbrevm_pass resbrevm_passpas resbrevf_pass resbrevf_passpas resbrevm_pass2 resbrevm_passpas2 resbrevf_pass2 resbrevf_passpas2  /*
*/ vrais_indiv weight_sum weight_vrais diff diff_sum_square repett vrais a
}

if mod(`iter',5)==0 {

di "Nb d'iterations =" `iter'

di "Heure : $S_TIME" 

di "crit ="  `crit'

di "Loglikelihood=" `llk'

}

}

xi : reg mathel_std i.group_cat  [pweight=prob_indiv]

scalar theta1=_b[_cons] 

di theta1

}


/* After convergence : results interpretation */
* Critre BIC  4points(3170802.4) 3points(2181264.7)

di -2*`llk'+4*log(_N/4)

run probsimple.do

di -2*`llk'+4*log(_N/4)

/*************************************************************/
/***********Correlation prob_indiv prob_indiv2***************/
/***********************************************************/

reg prob_indiv prob_indiv2

corr prob_indiv prob_indiv2 

/*************************************************************/
/***********Estimation results with prob_indiv***************/
/***********************************************************/

xi : reg mathel_std i.group_cat  [pweight=prob_indiv]

gen thetam=_b[_cons] if group_cat==1
replace thetam=_b[_cons]+_b[ _Igroup_cat_2] if group_cat==2
replace thetam=_b[_cons]+_b[ _Igroup_cat_3] if group_cat==3
replace thetam=_b[_cons]+_b[ _Igroup_cat_4] if group_cat==4

tab thetam, gen(group)
label var group2 "Group 2"
label var group3 "Group 3"
label var group4 "Group 4"

save BDD_2012_p0,replace

drop group_cat
gen group_cat=1*(group1)+2*(group2)+3*(group3)+4*(group4)

set more off
gen repett=0

bysort thetam : egen effect_prob=sum(prob_indiv)
tab effect_prob thetam 
drop effect_prob
bysort repet thetam : egen effect_prob=sum(prob_indiv)
tab effect_prob thetam if repet==2
tab effect_prob thetam if repet==1
tab effect_prob thetam if repet==0
drop effect_prob

/*Math and French score before the entrance to grade 6 */
/*Prediction du capital humain*/

xi : reg mathel_std group2-group4  [pweight=prob_indiv]
est store mathel

xi : reg franel_std group2-group4  [pweight=prob_indiv]
est store franel 
outreg2 [mathel franel] using simu1,tex(fragment) label  replace

/*Size of class*/

xi : reg ned1 ned1_th secteur1  eff_etab_t1 tuetab12-tuetab19 net1_tr2-net1_tr3 lv11_all inzep1 /* 
*/ group2-group4 [pweight=prob_indiv]
outreg2 using simu2,tex(fragment) label  replace 

xi : oprobit pass1 ned1 secteur1 lv11_all inzep1 group2-group4 [pweight=prob_indiv]
predict P1
outreg2 using simu3,tex(fragment) label  replace 

replace repett=1 if pass1==0

bysort repett thetam : egen effect_prob=sum(prob_indiv)
tab effect_prob thetam if repett==1
drop effect_prob

xi : reg ned2 ned2_th secteur2 eff_etab_t2 tuetab22-tuetab29 lv12_all lv12_othe inzep2 /* 
*/ group2-group4  [pweight=prob_indiv] if repett==0
est store passn2
predict n2contrefact if repett==1
replace n2contrefact=n2contrefact+_b[ned2_th]*(ned2_th_c-ned2_th)

xi : reg ned2 ned2_th tuetab28 tuetab29 net2_tr3 lv12_all inzep2 group2-group4  [pweight=prob_indiv] if repett==1
est store repeatn2
predict n2Rcontrefact if repett==0
replace n2Rcontrefact= n2Rcontrefact+_b[ned2_th]*(ned2_th_c-ned2_th) 

outreg2 [passn2 repeatn2] using simu4,tex(fragment) label  replace 

xi : oprobit pass2 ned2 tuetab28 tuetab29 net2_tr3 lv12_all inzep2 /* 
*/ group2-group4   [pweight=prob_indiv] if pass1==1
est store pass2
predict P20 P21 P22 if repett==0
predict P2xb if repett==1, xb 
replace P2xb=P2xb+_b[ned2]*(n2contrefact-ned2)
gen P20contrefact=normprob(_b[/cut1]-P2xb)
gen P21contrefact=normprob(_b[/cut2]-P2xb)-normprob(_b[/cut1]-P2xb)
gen P22contrefact=normprob(P2xb-_b[/cut2])

xi : oprobit pass2 ned2 tuetab23 tuetab26 tuetab27 tuetab29 net2_tr3  /* 
*/ group2-group4 [pweight=prob_indiv] if repett==1
predict P2r if repett==1,outcome(2)
predict P2xbr if repett==0, xb
replace P2xbr=P2xbr+_b[ned2]*(n2Rcontrefact-ned2)
gen P2Rcontrefact=normprob(P2xbr-_b[/cut1])

est store repeatpass2

outreg2 [pass2 repeatpass2] using simu5,tex(fragment) label  replace 

replace repett=1 if pass2==1
replace repett=. if pass2==0

bysort repett thetam : egen effect_prob=sum(prob_indiv)
tab effect_prob thetam if repett==1
drop effect_prob

xi : reg ned3 ned3_th  secteur3 eff_etab_t3 tuetab32-tuetab39 net3_tr2 lv13_all inzep3 /* 
*/ group2-group4  [pweight=prob_indiv] if repett==0
est store passn3
predict n3contrefact if repett==1
replace n3contrefact=n3contrefact+_b[ned3_th]*(ned3_th_cr-ned3_th)
replace n3contrefact= _b[ned3_th]*ned3_th_cr+_b[secteur3]*secteur2+_b[eff_etab_t3]*eff_etab_t3_c+_b[tuetab32]*tuetab22+_b[tuetab33]*tuetab23 /*
*/ +_b[tuetab34]*tuetab24+_b[tuetab35]*tuetab25 +_b[tuetab36]*tuetab26+_b[tuetab37]*tuetab27+_b[tuetab38]*tuetab28 +_b[tuetab39]*tuetab29/*
*/ +_b[net3_tr2]*net2_tr2+_b[lv13_all]*lv12_all+_b[inzep3]*inzep2+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4+_b[_cons]  if repett==. 


xi : reg ned3 ned3_th secteur3 eff_etab_t3 tuetab33 tuetab39 net3_tr3 lv13_all inzep3 /* 
*/ group2-group4  [pweight=prob_indiv] if repett==1
est store repeatn3
predict n3Rcontrefact if repett==0 
replace n3Rcontrefact= n3Rcontrefact+_b[ned3_th]*(ned3_th_c-ned3_th)
replace n3Rcontrefact= _b[ned3_th]*ned3_th_c+_b[secteur3]*secteur2+_b[eff_etab_t3]*eff_etab_t3_c+_b[tuetab33]*tuetab23+_b[tuetab39]*tuetab29 /*
*/ +_b[net3_tr3]*net2_tr3+_b[lv13_all]*lv12_all+_b[inzep3]*inzep2+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4+_b[_cons]  if repett==. 

outreg2 [passn3 repeatn3] using simu6,tex(fragment) label  replace 


xi : oprobit pass3 ned3 eff_etab_t3 tuetab33 tuetab34 net3_tr3 lv13_all group2-group4 [pweight=prob_indiv] if repett==0
est store pass3
predict P30 P31 P32 if repett==0
predict P3xb if repett==1, xb 
replace P3xb=P3xb+_b[ned3]*(n3contrefact-ned3)
replace P3xb= _b[ned3]*n3contrefact+_b[eff_etab_t3]*eff_etab_t3_c+_b[tuetab33]*tuetab23+_b[tuetab34]*tuetab24+_b[net3_tr3]*net2_tr3+_b[lv13_all]*lv12_all+_b[group2]*group2 /*
*/ +_b[group3]*group4 if repett==.
gen P30contrefact=normprob(_b[/cut1]-P3xb)
gen P31contrefact=normprob(_b[/cut2]-P3xb)-normprob(_b[/cut1]-P3xb)
gen P32contrefact=normprob(P3xb-_b[/cut2])


xi : oprobit pass3 ned3 tuetab39 net3_tr2-net3_tr3 lv13_all group2-group4  [pweight=prob_indiv] if repett==1
est store repeatpass3
predict P3r if repett==1,outcome(2)
predict P3xbr if repett==0, xb
replace P3xbr=P3xbr+_b[ned3]*(n3Rcontrefact-ned3)
replace P3xbr=_b[ned3]*n3Rcontrefact+_b[tuetab39]*tuetab29+_b[net3_tr2]*net2_tr2+_b[net3_tr3]*net2_tr3+_b[lv13_all]*lv12_all+_b[group2]*group2 /*
*/ +_b[group3]*group4 if repett==.
gen P3Rcontrefact=normprob(P3xbr-_b[/cut1])

outreg2 [pass3 repeatpass3] using simu7,tex(fragment) label  replace 

replace repett=1 if pass3==1
replace repett=. if pass3==0

xi : reg ned4 ned4_th secteur4 eff_etab_t4 tuetab42-tuetab49 lv14_all inzep4 group2-group4  [pweight=prob_indiv]  if repett==0
est store passn4
predict n4contrefact if repett==1
replace n4contrefact=n4contrefact+_b[ned4_th]*(ned4_th_cr-ned4_th) 
replace n4contrefact=_b[ned4_th]*ned4_th_cr+_b[secteur4]*secteur2+_b[eff_etab_t4]*eff_etab_t4_c+_b[tuetab42]*tuetab22+_b[tuetab43]*tuetab23/*
*/+_b[tuetab44]*tuetab24+_b[tuetab45]*tuetab25+_b[tuetab46]*tuetab26+_b[tuetab47]*tuetab27+_b[tuetab48]*tuetab28+_b[tuetab49]*tuetab29  /*
*/+_b[lv14_all]*lv12_all+_b[inzep4]*inzep2+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4+_b[_cons] if repett==.


xi : reg ned4 ned4_th secteur4 eff_etab_t4 tuetab42-tuetab44 tuetab46 tuetab48-tuetab49 lv14_all inzep4 /* 
*/  group2-group4  [pweight=prob_indiv]  if repett==1
est store repeatn4
predict n4Rcontrefact if repett==0
replace n4Rcontrefact=n4Rcontrefact+_b[ned4_th]*(ned4_th_c-ned4_th) 
replace n4Rcontrefact=_b[ned4_th]*ned4_th_c+_b[secteur4]*secteur2+_b[eff_etab_t4]*eff_etab_t4_c+_b[tuetab42]*tuetab22+_b[tuetab43]*tuetab23/*
*/+_b[tuetab44]*tuetab24+_b[tuetab46]*tuetab26+_b[tuetab48]*tuetab28+_b[tuetab49]*tuetab29  /*
*/+_b[lv14_all]*lv12_all+_b[inzep4]*inzep2+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4+_b[_cons] if repett==.


outreg2 [passn4 repeatn4] using simu8,tex(fragment) label replace 

xi : oprobit pass4 ned4 secteur4 tuetab43 tuetab44 tuetab46 tuetab48 tuetab49  /* 
*/ group2-group4  [pweight=prob_indiv] if repett==1
predict P4r if repett==1,outcome(1)
predict P4xbr if repett==0, xb
replace P4xbr=P4xbr+_b[ned4]*(n4Rcontrefact-ned4)
replace P4xbr=_b[ned4]*n4Rcontrefact+_b[tuetab43]*tuetab23+_b[tuetab44]*tuetab24+_b[tuetab46]*tuetab26+_b[tuetab48]*tuetab28+_b[tuetab49]*tuetab29 /*
*/ +_b[group2]*group2+_b[group3]*group4 if repett==.
gen P4Rcontrefact=normprob(P4xbr-_b[/cut1])

replace repett=. if pass4==0

outreg2 using simu9,tex(fragment) label  replace

xi : reg ned5 ned5_th eff_etab_t5 tuetab52 tuetab56-tuetab59 net5_tr4 lv15_all inzep5 /* 
*/ group2-group4 [pweight=prob_indiv] if repet==1
gen n5contrefact=_b[_cons]+_b[ned5_th]*ned5_th_c+_b[eff_etab_t5]*eff_etab_t4 +_b[tuetab52]*(tuetab4=="1")+_b[tuetab56]*(tuetab4=="5")+_b[tuetab57]*(tuetab4=="6") /*
*/+_b[tuetab58]*(tuetab4=="7")+_b[tuetab59]*(tuetab4=="8") /*
*/+_b[net5_tr4]*(net4_tr==3)+_b[lv15_all]*lv14_all /*
*/+_b[inzep5]*inzep4+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0
outreg2 using simu10,tex(fragment) label replace

xi : reg grade9_mat_std ned4 secteur4 tuetab45 tuetab47 net4_tr4 lv14_all inzep4 /* 
*/  group2-group4  [pweight=prob_indiv] if repet==0
predict grade9m_ifpass if repet==1
replace grade9m_ifpass=grade9m_ifpass+_b[ned4]*(n4contrefact-ned4) if repet==1
est store math_pass

*Test juste sur les groupes
*xi : reg grade9_mat_std group2-group4  [pweight=prob_indiv] if repet==0
*predict grade9m_ifpass if repet==1


xi : reg grade9_fra_std ned4 tuetab46 lv14_all inzep4 /* 
*/ group2-group4  [pweight=prob_indiv] if repet==0
predict grade9f_ifpass if repet==1
replace grade9f_ifpass=grade9f_ifpass+_b[ned4]*(n4contrefact-ned4) if repet==1
est store french_pass

/* Student who did a retention but are in the general field */

xi : reg grade9_mat_std ned5 secteur5 tuetab57 tuetab59 net5_tr4 group2-group4  [pweight=prob_indiv] if repet==1
gen grade9m_ifpasspas =_b[_cons]+_b[ned5]*n5contrefact+_b[secteur5]*(secteur4==1)+_b[tuetab57]*(tuetab4=="6")+_b[tuetab59]*(tuetab4=="8") /*
*/+_b[net5_tr4]*(net4_tr==3)+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0
est store repeatmath

*Test juste sur les groupes
*xi : reg grade9_mat_std group2-group4  [pweight=prob_indiv] if repet==1
*predict grade9m_ifpasspas if repet==0

xi : reg grade9_fra_std ned5 secteur5 tuetab54  /* 
*/ group2-group4  [pweight=prob_indiv] if repet==1
gen grade9f_ifpasspas =_b[_cons]+_b[ned5]*n5contrefact +_b[secteur5]*(secteur4==1)+_b[tuetab54]*(tuetab4=="3") /*
*/+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0
est store repeatfrench

outreg2 [math_pass repeatmath french_pass repeatfrench] using simu11,tex(fragment)  label  replace

outreg2 [mathel math_pass repeatmath franel french_pass repeatfrench] using simu12,tex(fragment) keep(ned4 ned5 group2-group4) sortvar(ned4 ned5 group2-group4)  label  replace

*tabout prob1 thetam using table,rep style(tex)

/* Rajout du mois de naissance */
sort ident
merge m:1 ident using panel95c, keepusing(quarter)
drop _merge

forvalues i =1/4 {
xi : reg prob_indiv i.quarter femme dipm2-dipm6 cspp2-cspp7 nbenf3 nbenf4etplus redoub_prim pere_et mere_et prim_priv /*
*/ secteur1 eff_etab_t1 tuetab12-tuetab19 net1_tr2-net1_tr4 lv11_all lv11_othe inzep1 /*
*/ secteur2 eff_etab_t2 tuetab22-tuetab29 net2_tr2-net2_tr4 lv12_all lv12_othe inzep2 /*
*/ secteur3 eff_etab_t3 tuetab32-tuetab39 net3_tr2-net3_tr4 lv13_all lv13_othe inzep3 /*
*/ secteur4 eff_etab_t4 tuetab42-tuetab49 net4_tr2-net4_tr4 lv14_all lv14_othe inzep4 /*
*/ if group`i'
predict pg`i' 
est store G`i'

}

outreg2 [G1 G2 G3 G4] using simu13,tex(fragment) label  replace

*xi : mlogit group_cat femme i.dipm i.cspp nbenf3 nbenf4etplus redoub_prim pere_et mere_et prim_priv [pweight=prob_indiv],rrr baseoutcome(1)
*outreg2 using simu12,tex(fragment) replace

/*
* Prediction of contrefacts 
gen n4contrefact=14.5+0.33*ned4_th_c+0.002*eff_etab_t4 +0.922*(secteur4==1)+0.27*(tuetab4=="1")+0.57*(tuetab4=="2") /*
*/ +0.587*(tuetab4=="3")+0.68*(tuetab4=="4")+0.58*(tuetab4=="5")+1.13*(tuetab4=="6") /*
*/+0.99*(tuetab4=="7")+1.52*(tuetab4=="8") +0.322*lv14_all-1.34*inzep4+1.93*group3+2.54*group4 if repet==1

gen n5contrefact=16.27+0.26*ned5_th_c+0.002*eff_etab_t5_c +0.83*(tuetab4=="5")+0.77*(tuetab4=="6") /*
*/+0.88*(tuetab4=="7")+1.34*(tuetab4=="8")+0.54*(net4_tr==2)+1.2*(net4_tr==3)+0.98*lv14_all-1.91*inzep4 if repet==0

gen grade9m_ifpass=40.32+1.1*(secteur4==1)-1.37*(tuetab4=="6") /*
*/+2.38*(net4_tr==3)+0.6*lv14_all+1.25*inzep4+8.67*group2+13.77*group3+24.34*group4 if repet==1

gen grade9f_ifpass=39.50+0.89*lv14_all+1.71*inzep4+9.57*group2+14.61*group3+25.53*group4 if repet==1

gen grade9m_ifpasspas =44.65-0.24*n5contrefact-1.61*(tuetab4=="6") +3.1*(net4_tr==3)+6.5*group2+6.4*group3+12.3*group4 if repet==0

gen grade9f_ifpasspas =44.3-0.25*n5contrefact+2.02*(secteur4==1)+1.94*(tuetab4=="3")+6.68*group2+7.29*group3+11.41*group4 if repet==0

*/

* ATE et ATT

save BDD_2012_2,replace

* Scores
gen Effectm=(grade9m_ifpasspas-grade9_mat_std) if repet==0
replace Effectm=(grade9_mat_std-grade9m_ifpass) if repet==1

gen Effectf=(grade9f_ifpasspas-grade9_fra_std) if repet==0
replace Effectf=(grade9_fra_std-grade9f_ifpass) if repet==1

* Proba to reach grade 9  /*  P1*P22*P32 + P1*P22*P31*P4r + P1*P21*P3r*P4r + (1-P1)*P2r*P3r*P4r  */
gen Select= P1*P22*P32 + P1*P22*P31*P4Rcontrefact + P1*P21*P3Rcontrefact*P4Rcontrefact + (1-P1)*P2Rcontrefact*P3Rcontrefact*P4Rcontrefact if voie1234
replace Select=P1*P22*P32 + P1*P22*P31*P4r + P1*P21*P3Rcontrefact*P4r + (1-P1)*P2Rcontrefact*P3Rcontrefact*P4r  if voie12334 | voie1233V
replace Select=P1*P22*P32contrefact + P1*P22*P31contrefact*P4r + P1*P21*P3r*P4r + (1-P1)*P2Rcontrefact*P3r*P4r  if voie12234 | voie1223V
replace Select=P1*P22contrefact*P32contrefact + P1*P22contrefact*P31contrefact*P4r + P1*P21contrefact*P3r*P4r + (1-P1)*P2r*P3r*P4r  if voie11234 | voie1123V
replace Select=P1*P22*P32 + P1*P22*P31*P4Rcontrefact + P1*P21*P3Rcontrefact*P4Rcontrefact + (1-P1)*P2Rcontrefact*P3Rcontrefact*P4Rcontrefact if voie123V 
replace Select=P1*P22*P32contrefact + P1*P22*P31contrefact*P4Rcontrefact + P1*P21*P3r*P4Rcontrefact + (1-P1)*P2Rcontrefact*P3r*P4Rcontrefact if voie122V 
replace Select=P1*P22contrefact*P32contrefact + P1*P22contrefact*P31contrefact*P4Rcontrefact + P1*P21contrefact*P3r*P4Rcontrefact + (1-P1)*P2r*P3r*P4Rcontrefact if voie112V 
replace Select=P1*P22*P32contrefact + P1*P22*P31contrefact*P4Rcontrefact + P1*P21*P3Rcontrefact*P4Rcontrefact + (1-P1)*P2Rcontrefact*P3Rcontrefact*P4Rcontrefact if voie12V 
replace Select=P1*P22contrefact*P32contrefact + P1*P22contrefact*P31contrefact*P4Rcontrefact + P1*P21contrefact*P3Rcontrefact*P4Rcontrefact + (1-P1)*P2r*P3Rcontrefact*P4Rcontrefact if voie11V 

* Proba to reach grade 9 if grade retention is forbidden /*  (P21+P22)*(P31+P32) */
gen Select2= (P21+P22)*(P31+P32) if voie1234 | voie12334 | voie1233V | voie123V 
replace Select2=  (P21+P22)*(P31contrefact+P32contrefact) if voie12234 | voie1223V | voie122V | voie12V
replace Select2= (P21contrefact+P22contrefact)*(P31contrefact+P32contrefact) if voie11234 | voie1123V | voie112V | voie11V

* Histogramme


label variable Select "Probability"
label variable Select2 "Counterfactual Probability"

label define group 1 "Group 1" 2 "Group 2" 3 "Group 3" 4 "Group 4"
label values group_cat group 

twoway histogram Select [fweight=10*round(prob_indiv)], start(0.35) width(0.01) bfcolor(white) blcolor(black) percent || histogram Select2 [fweight=10*round(prob_indiv)] , start(0.35) width(0.01) bfcolor(grey) blcolor(black) barw(0.01) percent legend(order(1 "`: var label Select'" 2 "`: var label Select2'"))

sort group_cat
hist Select [fweight=10*round(prob_indiv)], bin(20) by(group_cat, note(')) percent 
hist Select2[fweight=10*round(prob_indiv)], bin(20) by(group_cat, note(')) percent 

* Effects

gen Effect_sel=Select2-Select

sum Effectm Effectf Effect_sel [weight=prob_indiv]
sum Effectm Effectf Effect_sel [weight=prob_indiv] if repet==1

bysort group_cat: sum Effectm Effectf Effect_sel   [weight=prob_indiv]

bysort group_cat : sum Effectm Effectf Effect_sel  [weight=prob_indiv] if repet==1


* ned4 (ou ned4contrefact) secteur4 tuetab45 tuetab47 net4_tr4 lv14_all inzep4
* ned5 (ou ned5contrefact) secteur5 tuetab57 tuetab59 net5_tr4 

save BDD_2012_3,replace

      /*******************************************/
     /*******************************************/
    /******* Classification stricte ************/
   /*******************************************/
  /*******************************************/


bysort ident : egen prob_max=max(prob_indiv)
gen group_sim=group_cat if prob_max==prob_indiv
bysort ident : egen g=max(group_sim)
replace group_sim=g
drop g

bysort ident : egen prob_max2=max(prob_indiv2)
gen group_sim2=group_cat if prob_max2==prob_indiv2
bysort ident : egen g=max(group_sim2)
replace group_sim2=g
drop g

tab group_sim group_sim2

tabout group_sim group_sim2 using "C:\Users\Toshiba\Dropbox\Redoublement\classif.tex" , replace style(tex)

* Test sur les lves les moins prdtermins

sum Effectm Effectf Effect_sel [weight=prob_indiv] if group_sim != group_sim2
sum Effectm Effectf Effect_sel [weight=prob_indiv] if repet==1 & group_sim != group_sim2

bysort group_cat: sum Effectm Effectf Effect_sel   [weight=prob_indiv] if group_sim != group_sim2

bysort group_cat : sum Effectm Effectf Effect_sel  [weight=prob_indiv] if repet==1 & group_sim != group_sim2

/* *Classification stricte
keep if group_cat==group_sim & prob_max!=.

drop  repett- Effectf

set more off
gen repett=0

tab thetam 

tab repet thetam

run classtrict.do
*/


