clear all

cd "C:\Users\Toshiba\Dropbox\Redoublement"

sysdir set PERSONAL "C:\Users\Toshiba\Dropbox\Redoublement\ado\personal"
sysdir set PLUS "C:\Users\Toshiba\Dropbox\Redoublement\ado\plus"
set mem 800m

use panel95c ,replace

set more off

keep ident mathel_std franel_std femme dipm dipm1-dipm6 cspp cspp1-cspp7 age6e rang2 rang3 rang4etplus nbenf3 nbenf4etplus /*
*/ mere_et pere_et prim_priv pass1 pass2 pass3 pass4 general grade9_fra_std grade9_mat_std redoub_prim repet /*
*/ ned1 ned1_th tuetab1 tuetab11-tuetab19 secteur1 net1_tr net1_tr1-net1_tr4 effectif_grade_1 eff_etab_t1 lv11_all lv11_ang lv11_othe  inzep1  /*
*/ ned2 ned2_th ned2_th_c tuetab2 tuetab21-tuetab29  secteur2 net2_tr net2_tr1-net2_tr4 effectif_grade_2 eff_etab_t2 lv12_all lv12_ang lv12_othe  inzep2   /*
*/ ned3 ned3_th ned3_th_c ned3_th_cr tuetab3 tuetab31-tuetab39  secteur3 net3_tr net3_tr1-net3_tr4 effectif_grade_3 eff_etab_t3_c eff_etab_t3 lv13_all lv13_ang lv13_othe  inzep3  /*
*/ ned4 ned4_th ned4_th_c ned4_th_cr tuetab4 tuetab41-tuetab49 secteur4 net4_tr net4_tr1-net4_tr4 effectif_grade_4 effectif_grade_4_c eff_etab_t4 eff_etab_t4_c lv14_all lv14_ang lv14_othe  inzep4  /*
*/ ned5 ned5_th ned5_th_c ned5_th_cr tuetab5 tuetab51-tuetab59 secteur5 net5_tr net5_tr1-net5_tr4 effectif_grade_5 effectif_grade_5_c eff_etab_t5 eff_etab_t5_c lv15_all lv15_ang lv15_othe  inzep5  /*
*/ voie1234 voie11234 voie12234 voie12334 voie123V voie12V voie11V voie122V voie1233V voie1223V voie1123V voie112V quarter

foreach i of varlist mathel_std franel_std  /*
*/ ned1 ned1_th tuetab1 secteur1 net1_tr eff_etab_t1 lv11_all lv11_othe inzep1 {

drop if missing(`i')
}

foreach i of varlist /*
*/ ned2 ned2_th tuetab2 secteur2 net2_tr eff_etab_t2 lv12_all lv12_othe inzep2  /*
*/ ned3 ned3_th tuetab3 secteur3 net3_tr eff_etab_t3 lv13_all lv13_othe inzep3  /*
*/ ned4 ned4_th tuetab4 secteur4 net4_tr eff_etab_t4 lv14_all lv14_othe inzep4  {

drop if missing(`i') & repet<2
}

foreach i of varlist voie1234 voie11234 voie12234 voie12334 voie123V voie12V voie11V voie122V voie1233V voie1223V voie1123V voie112V {
tab `i'
}

save BDD_2012,replace

recode grade9_fra_std .=-1
recode grade9_mat_std .=-1
recode pass3 .=-1
recode pass4 .=-1
recode effectif_grade_5 .=0
recode eff_etab_t5 .=0
recode effectif_grade_4 .=0
recode eff_etab_t4 .=0

replace pass3=. if pass3==-1
replace pass4=. if pass4==-1

scalar p1=0.18
scalar p2=0.29
scalar p3=0.30
scalar p4=1-p1-p2-p3
*scalar p5=1-p1-p2-p3-p4


save BDD_2012,replace

scalar theta1=40
use BDD_2012,replace

scalar size=_N
/*Initialisation of weights */

save BDD_2012b,replace

forvalues i =1/2 {
append using BDD_2012b
save BDD_2012b,replace
}

bysort ident : gen group_cat=_n

scalar k1=-1+2*runiform()
scalar k2=-1+2*runiform()
scalar k3=-1+2*runiform()
scalar p1=1/(1+exp(k1)+exp(k2)+exp(k3))
scalar p2=exp(k1)/(1+exp(k1)+exp(k2)+exp(k3))
scalar p3=exp(k2)/(1+exp(k1)+exp(k2)+exp(k3))
scalar p4=exp(k3)/(1+exp(k1)+exp(k2)+exp(k3))

gen prob1=p1
replace prob1=p2 if group_cat==2
replace prob1=p3 if group_cat==3
replace prob1=p4 if group_cat==4


  /*************/
 /*  STEP 0   */
/*************/

char cspp[omit] 5
char dipm[omit] 1
char inzep1[omit] 2
char inzep2[omit] 2
char inzep3[omit] 2
char inzep4[omit] 2
char inzep5[omit] 2
xi : reg mathel_std femme cspp3 dipm6 redoub_prim i.group_cat ,nocons
predict resm,res
su resm 
scalar sigma_resm=r(sd)

xi : reg franel_std  femme cspp3 dipm6 redoub_prim i.group_cat,nocons
predict resf,res
su resf
scalar sigma_resf=r(sd)

xi : reg ned1 femme cspp3 dipm6 redoub_prim i.tuetab1 i.secteur1 effectif_grade_1 eff_etab_t1 lv11_all lv11_othe inzep1 /*
*/pere_et prim_priv i.group_cat , nocons
predict resn1,res
su resn1
scalar sigma_resn1=r(sd)

gen vrais_indiv=normalden(resn1,0,sigma_resn1)*normalden(resf,0,sigma_resf)*normalden(resm,0,sigma_resm)

/* Build the individual weight */

gen weight_vrais=prob1*vrais_indiv
bysort ident : egen weight_sum=total(weight_vrais)

gen prob_indiv=prob1*vrais_indiv/weight_sum

drop resn1 vrais_indiv weight_sum weight_vrais 

scalar drop sigma_resn1

/* Iterations until convergence */

gen prob2=prob1
gen prob_indiv2=prob_indiv

set more off
local crit=1
local iter=1
local llk=0

di "Program started on $S_DATE at $S_TIME" 
while `iter'<1000 & `crit'>0.00001 {

quietly{

run Model55X.do


gen vrais_indiv=normalden(resm0,0,sigma_resm0)*normalden(resf0,0,sigma_resf0)*normalden(resn1,0,sigma_resn1) /*
*/ *P1^pass1*(1-P1)^(1-pass1) /*
*/ *normalden(resn2,0,sigma_resn2)^(pass1==1)*normalden(resn2r,0,sigma_resn2r)^(pass1==0) /*
*/ *(P20^(pass2==0)*P21^(pass2==1)*P22^(pass2==2))^(pass1==1)*((1-P2r)^(pass2==0)*P2r^(pass2==2))^(pass1==0)  /*
*/ *normalden(resn3,0,sigma_resn3)^(pass2==2 & pass1==1)*normalden(resn3r,0,sigma_resn3r)^((pass2==2 & pass1==0) |(pass2==1 & pass1==1) ) /*
*/ *(P30^(pass3==0)*P31^(pass3==1)*P32^(pass3==2))^(pass2==2 & pass1==1)*((1-P3r)^(pass3==0)*P3r^(pass3==2))^((pass2==2 & pass1==0) |(pass2==1 & pass1==1) ) /*
*/ *normalden(resn4,0,sigma_resn4)^(repet==0)*normalden(resn4r,0,sigma_resn4r)^(repet==1) /*
*/ *P4^(pass4==1)*(1-P4)^(pass4==0) /*
*/ *normalden(resn5,0,sigma_resn5)^(repet==1) /*                            
*/ *normalden(resbrevm_pass,0,sigma_resbrevm_pass)^(repet==0)*normalden(resbrevm_passpas,0,sigma_resbrevm_passpas)^(repet==1) /*
*/ *normalden(resbrevf_pass,0,sigma_resbrevf_pass)^(repet==0)*normalden(resbrevf_passpas,0,sigma_resbrevf_passpas)^(repet==1) 


/* Build the individual weight */

gen weight_vrais=prob1*vrais_indiv
bysort ident : egen weight_sum=total(weight_vrais)

gen weight_indiv_prim=prob1*vrais_indiv/weight_sum

/* New type weights using constraints */

bysort group_cat : egen prob_prim=mean(weight_indiv_prim)

/*
bysort group_cat : egen sum_prob_indiv=total(prob_indiv)
gen pondm=prob_indiv*resm
gen pondf=prob_indiv*resf
bysort group_cat : egen pond2m=total(pondm)
bysort group_cat : egen pond2f=total(pondf)
bysort group_cat : gen thetam2=pond2m/sum_prob_indiv
bysort group_cat : gen thetaf2=pond2f/sum_prob_indiv

drop pondm pond2m pondf pond2f sum_prob_indiv 
*/

/*Calcul de la vraisemblance total*/
gen a=log(weight_sum)/4

gen vrais=sum(a)
su vrais
local llk=r(mean)

*gen diff= (prob1-prob_prim)^2 +(thetam-thetam2)^2+(thetaf-thetaf2)^2
gen diff= (prob1-prob_prim)^2 

egen diff_sum_square=sum(diff)

sum diff_sum_square

local crit=r(mean)
local iter=`iter'+1

/* Actualisation of weight */

/*
drop prob1 prob_indiv thetam thetaf
rename prob_prim prob1
rename weight_indiv_prim prob_indiv
rename thetam2 thetam
rename thetaf2 thetaf
*/
drop prob1 prob_indiv 
rename prob_prim prob1
rename weight_indiv_prim prob_indiv

drop resm0 resf0 resm02 resf02 resn1 resn12 resn22 resn2 resn3 resn32 resn4 resn42 resn5 resn52 /*
*/ resn22r resn2r resn3r resn32r resn4r resn42r resn5 resn52 P1 P4 P20 P21 P22 P30 P31 P32 P2r P3r  /*
*/ resbrevm_pass resbrevm_passpas resbrevf_pass resbrevf_passpas resbrevm_pass2 resbrevm_passpas2 resbrevf_pass2 resbrevf_passpas2  /*
*/ vrais_indiv weight_sum weight_vrais diff diff_sum_square repett vrais a
}

if mod(`iter',5)==0 {

di "Nb d'iterations =" `iter'

di "Heure : $S_TIME" 

di "crit ="  `crit'

di "Loglikelihood=" `llk'

}

}

xi : reg mathel_std femme cspp3 dipm6 redoub_prim i.group_cat  [pweight=prob_indiv]

scalar theta1=_b[_cons] 

di theta1



/* After convergence : results interpretation */
* Critre BIC  4points(3170802.4) 3points(2181264.7)

di -2*`llk'+4*log(_N/4)

run probsimple.do

di -2*`llk'+4*log(_N/4)

/*************************************************************/
/***********Correlation prob_indiv prob_indiv2***************/
/***********************************************************/

reg prob_indiv prob_indiv2

corr prob_indiv prob_indiv2 

/*************************************************************/
/***********Estimation results with prob_indiv***************/
/***********************************************************/

xi : reg mathel_std femme cspp3 dipm6 redoub_prim i.group_cat  [pweight=prob_indiv]

gen thetam=_b[_cons] if group_cat==1
replace thetam=_b[_cons]+_b[ _Igroup_cat_2] if group_cat==2
replace thetam=_b[_cons]+_b[ _Igroup_cat_3] if group_cat==3
replace thetam=_b[_cons]+_b[ _Igroup_cat_4] if group_cat==4

tab thetam, gen(group)
label var group2 "Group 2"
label var group3 "Group 3"
label var group4 "Group 4"

save BDD_2012_p0X,replace

drop group_cat
gen group_cat=1*(group1)+2*(group2)+3*(group3)+4*(group4)

set more off
gen repett=0


replace repett=1 if pass1==0

replace repett=1 if pass2==1
replace repett=. if pass2==0

replace repett=1 if pass3==1
replace repett=. if pass3==0

xi : reg ned4 ned4_th femme cspp3 dipm6 redoub_prim secteur4 eff_etab_t4 tuetab42-tuetab49 lv14_all inzep4 group2-group4  [pweight=prob_indiv]  if repett==0
est store passn4
predict n4contrefact if repett==1
replace n4contrefact=n4contrefact+_b[ned4_th]*(ned4_th_cr-ned4_th) 

xi : reg ned4 ned4_th femme cspp3 dipm6 redoub_prim secteur4 eff_etab_t4 tuetab42-tuetab44 tuetab46 tuetab48-tuetab49 lv14_all inzep4 /* 
*/  group2-group4  [pweight=prob_indiv]  if repett==1
est store repeatn4
predict n4Rcontrefact if repett==0
replace n4Rcontrefact=n4Rcontrefact+_b[ned4_th]*(ned4_th_c-ned4_th) 

replace repett=. if pass4==0

xi : reg ned5 ned5_th femme cspp3 dipm6 redoub_prim eff_etab_t5 tuetab52 tuetab56-tuetab59 net5_tr4 lv15_all inzep5 /* 
*/ group2-group4 [pweight=prob_indiv] if repet==1
gen n5contrefact=_b[_cons]+_b[ned5_th]*ned5_th_c+_b[femme]*femme+_b[cspp3]*cspp3+_b[dipm6]*dipm6+_b[redoub_prim]*redoub_prim /*
*/+_b[eff_etab_t5]*eff_etab_t4 +_b[tuetab52]*(tuetab4=="1")+_b[tuetab56]*(tuetab4=="5")+_b[tuetab57]*(tuetab4=="6") /*
*/+_b[tuetab58]*(tuetab4=="7")+_b[tuetab59]*(tuetab4=="8") /*
*/+_b[net5_tr4]*(net4_tr==3)+_b[lv15_all]*lv14_all /*
*/+_b[inzep5]*inzep4+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0

xi : reg grade9_mat_std ned4 femme cspp3 dipm6 redoub_prim secteur4 tuetab45 tuetab47 net4_tr4 lv14_all inzep4 /* 
*/  group2-group4  [pweight=prob_indiv] if repet==0
predict grade9m_ifpass if repet==1
replace grade9m_ifpass=grade9m_ifpass+_b[ned4]*(n4contrefact-ned4) if repet==1

xi : reg grade9_fra_std ned4 femme cspp3 dipm6 redoub_prim tuetab46 lv14_all inzep4 /* 
*/ group2-group4  [pweight=prob_indiv] if repet==0
predict grade9f_ifpass if repet==1
replace grade9f_ifpass=grade9f_ifpass+_b[ned4]*(n4contrefact-ned4) if repet==1

/* Student who did a retention but are in the general field */

xi : reg grade9_mat_std ned5 femme cspp3 dipm6 redoub_prim secteur5 tuetab57 tuetab59 net5_tr4 group2-group4  [pweight=prob_indiv] if repet==1
gen grade9m_ifpasspas =_b[_cons]+_b[ned5]*n5contrefact+_b[femme]*femme+_b[cspp3]*cspp3+_b[dipm6]*dipm6+_b[redoub_prim]*redoub_prim+_b[secteur5]*(secteur4==1)+_b[tuetab57]*(tuetab4=="6")+_b[tuetab59]*(tuetab4=="8") /*
*/+_b[net5_tr4]*(net4_tr==3)+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0

xi : reg grade9_fra_std ned5 femme cspp3 dipm6 redoub_prim secteur5 tuetab54  /* 
*/ group2-group4  [pweight=prob_indiv] if repet==1
gen grade9f_ifpasspas =_b[_cons]+_b[ned5]*n5contrefact+_b[femme]*femme+_b[cspp3]*cspp3+_b[dipm6]*dipm6+_b[redoub_prim]*redoub_prim +_b[secteur5]*(secteur4==1)+_b[tuetab54]*(tuetab4=="3") /*
*/+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0


/* Rajout du mois de naissance */
sort ident
merge m:1 ident using panel95c, keepusing(quarter)
drop _merge

forvalues i =1/4 {
xi : reg prob_indiv i.quarter femme dipm2-dipm6 cspp2-cspp7 nbenf3 nbenf4etplus redoub_prim pere_et mere_et prim_priv /*
*/ secteur1 eff_etab_t1 tuetab12-tuetab19 net1_tr2-net1_tr4 lv11_all lv11_othe inzep1 /*
*/ secteur2 eff_etab_t2 tuetab22-tuetab29 net2_tr2-net2_tr4 lv12_all lv12_othe inzep2 /*
*/ secteur3 eff_etab_t3 tuetab32-tuetab39 net3_tr2-net3_tr4 lv13_all lv13_othe inzep3 /*
*/ secteur4 eff_etab_t4 tuetab42-tuetab49 net4_tr2-net4_tr4 lv14_all lv14_othe inzep4 /*
*/ if group`i'
predict pg`i' 
est store G`i'

}

outreg2 [G1 G2 G3 G4] using simuProba_group,tex(fragment) label  replace
* ATE et ATT

save BDD_2012_2,replace

* Scores
gen Effectm=(grade9m_ifpasspas-grade9_mat_std) if repet==0
replace Effectm=(grade9_mat_std-grade9m_ifpass) if repet==1

gen Effectf=(grade9f_ifpasspas-grade9_fra_std) if repet==0
replace Effectf=(grade9_fra_std-grade9f_ifpass) if repet==1

* Effects

sum Effectm Effectf  [weight=prob_indiv]
sum Effectm Effectf  [weight=prob_indiv] if repet==1

bysort group_cat: sum Effectm Effectf [weight=prob_indiv]

bysort group_cat : sum Effectm Effectf [weight=prob_indiv] if repet==1

save BDD_2012_3,replace




