clear all

cd "C:\Users\Toshiba\Dropbox\Redoublement"

sysdir set PERSONAL "C:\Users\Toshiba\Dropbox\Redoublement\ado\personal"
sysdir set PLUS "C:\Users\Toshiba\Dropbox\Redoublement\ado\plus"
set mem 500m
use panel95a,replace

set more off

/* Reconversion des variables en variables numriques*/

drop if mathel=="AA"
drop if franel=="AA"

	foreach i of varlist mathel franel {				
		destring(`i'),gen (u)
		drop `i'
		rename u `i'					
	}
	
save panel95b,replace

/* Cration d'indicatrices et de variables synthtiques */


/* Table de redoublements par anne */
/*
6e 	601 , 6e de consolidation	602 ; 6e musique	603, 6e daccueil pour les trangers	604
5e 	501, 5e musique	502, 5e daccueil pour les trangers	503
4e gnrale (hors 4e daide et de soutien)	401
4e musique	402, 4e daccueil pour les trangers 403, 4e daide et de soutien (y compris ex 4e du dispositif amnag)	404
3e gnrale 	301 , 3e musique	302, 3e daccueil pour les trangers, 303, 3e dinsertion	304

orientation pro : 
4e technologique	405 4e agricole	406
3e technologique	305, 3e agricole	306, 3e  projet projet professionnel (LP)	307

Classes relais	701 ,UPI (unit pdagogique dintgration)	702, CPA (classe prparatoire  lapprentissage)	703
CLIPA (classe dinitiation prprofessionnelle en alternance, ex CIPPA)	704
SEGPA	
6e SEGPA	600
5e SEGPA	500
4e SEGPA	400
3e SEGPA	300

*/
* suppresion des valeurs manquantes ou aberrantes
drop if clas1=="3" /*exclusion des SEGPA*/
drop if clas2=="400" | clas2=="401" |clas2=="405" |clas2=="" | clas2=="600"
drop if clas3=="300" | clas3=="304" |clas3=="305" |clas3=="601" |clas3==""
drop if clas4=="501" | clas4==""
drop if clas5=="501" | substr(clas5,1,1)=="4"

* Exclure les 6me SEGPA
drop if clas1=="600"
* passent toutes les annes
gen voie1234 = ((clas2=="501") | (clas2=="502") |(clas2=="503")) & ((clas3=="401") |(clas3=="402") | /*
*/ (clas3=="403") |(clas3=="404") )&((clas4=="301") |(clas4=="302")|(clas4=="304")) 

*pour tous les autres, il nous faut clas5

drop if voie1234==0 & clas5==""

* Redoublent la 4eme et passent en 3eme
gen voie12334 =((clas2=="501") | (clas2=="502") |(clas2=="503")) & ( (clas3=="401") |(clas3=="402") | /*
*/(clas3=="403")| (clas3=="404"))& ((clas4=="401") |(clas4=="402")|(clas4=="404")) & ((clas5=="301") | /*
*/(clas5=="302")|(clas5=="304")) 

* redoublent la 4eme et sont rorients en 3me
gen voie1233V =((clas2=="501") | (clas2=="502") |(clas2=="503")) & ((clas3=="401") |(clas3=="402") | /*
*/(clas3=="403")|(clas3=="404"))& ((clas4=="401") |(clas4=="402")|(clas4=="404")) & ( (substr(clas5,1,1)=="7") | (substr(clas5,1,1)=="8") | clas5=="300"| clas5=="400"|clas5=="305"|clas5=="306")

*sont rorients en 3me aprs avoir pass 6eme et 5eme.
gen voie123V = ((clas2=="501") | (clas2=="502") |(clas2=="503")) & ((clas3=="401") |(clas3=="402") | /*
*/ (clas3=="403")|(clas3=="404"))&(substr(clas4,1,1)=="7" | clas4=="300" | clas4=="400" | clas4=="405" | clas4=="406" |clas4=="305"|clas4=="306")

*redoublent seulement la 5eme
gen voie12234 = ((clas2=="501") | (clas2=="502") |(clas2=="503")) & ( (clas3=="501") |(clas3=="502") | /*
*/ (clas3=="503"))&((clas4=="401") |(clas4=="402")|(clas4=="404"))  & ((clas5=="301") |(clas5=="302")|(clas5=="303")|(clas5=="304")) 

*redoublent seulement la 6eme
gen voie11234 = ((clas2=="601") | (clas2=="602") |(clas2=="604")) & ( (clas3=="501") |(clas3=="502") | /*
*/ (clas3=="503"))& ( (clas4=="401") |(clas4=="402")|(clas4=="404"))  & ((clas5=="301") |(clas5=="302")|(clas5=="303")|(clas5=="304")) 

*voie 1223V
gen voie1223V = ((clas2=="501") | (clas2=="502") |(clas2=="503")) & ((clas3=="501") |(clas3=="502") | /*
*/ (clas3=="503"))&((clas4=="401") |(clas4=="402")|(clas4=="404")) & ((substr(clas5,1,1)=="7") |(substr(clas5,1,1)=="8") | (clas5=="405")| (clas5=="406")| (clas5=="400")| (clas5=="306")| (clas5=="305"))

*voie 1123V
gen voie1123V = ((clas2=="601") | (clas2=="602") |(clas2=="604")) & ( (clas3=="501") |(clas3=="502") | /*
*/ (clas3=="503"))& ((clas4=="401") |(clas4=="402")|(clas4=="404"))  & ((substr(clas5,1,1)=="7") |(substr(clas5,1,1)=="8") | (clas5=="405")| (clas5=="406")| (clas5=="400")| (clas5=="306")| (clas5=="305"))

*voie 112V
gen voie112V = ((clas2=="601") | (clas2=="602") |(clas2=="604")) & ( (clas3=="501") |(clas3=="502") | /*
*/ (clas3=="503")) & ((substr(clas4,1,1)=="7") |(clas4=="405")| (clas4=="406")| (clas4=="400")| (clas4=="500"))

*voie 122V
gen voie122V = ((clas2=="501") | (clas2=="502") |(clas2=="503")) & ((clas3=="501") |(clas3=="502") | /*
*/ (clas3=="503"))& ((substr(clas4,1,1)=="7") |(clas4=="405")| (clas4=="406")| (clas4=="400")| (clas4=="500"))

*voie 11V
gen voie11V= ((clas2=="601") | (clas2=="602") |(clas2=="604")) & ((substr(clas3,1,1)=="7") |(clas3=="500"))

*voie 12V
gen voie12V = ((clas2=="501") | (clas2=="502") |(clas2=="503")) & ((substr(clas3,1,1)=="7") |(clas3=="405")| (clas3=="406")| (clas3=="400")|(clas3=="500"))

*voie 1V
gen voie1V = (clas2=="500")  |(substr(clas2,1,1)=="7") 

drop if voie1V

egen verif=rsum(voie1234-voie1V)
drop if verif==0

* Filire gnrale

gen general= (voie1234 |voie12334|voie12234|voie11234)
gen repetition = (1-voie1234)*general

gen repet=repetition
replace repet=2 if general==0

tab repet

*xi : reg mathel i.repet i.repetition i.general i.voie1V i.voie12V i.voie11V i.voie122V i.voie112V i.voie1123V i.voie1223V i.voie11234 i.voie12234 i.voie123V i.voie1233V i.voie12334 i.voie1234
*outreg2 repet using summary, tab replace tex(fragment)

gen monthbirth=substr(datenai,3,2)
destring monthbirth,gen(monthbirth_num)
drop monthbirth
rename monthbirth_num monthbirth

tab repetition monthbirth if general 

bysort monthbirth : sum repetition if general

* On ne regarde pas le score des redoublants de 3eme
replace brevfra2=. if repet==0
replace brevmat2=. if repet==0

*Ici, on ne garde que le gnral pour les stats desc et que ceux qui ont les grade 6 et 9 renseigns.

keep if (general & ((brevfra1!=. & brevmat1!=.)  | (brevfra2!=. & brevmat2!=.) )) | general==0

tab repet
tab voie1234
tab voie12334
tab voie12234
tab voie11234

* Les rorients ne devraient pas avoir de notes de 3me
replace brevfra1=. if general==0
replace brevmat1=. if general==0
replace brevfra2=. if general==0
replace brevmat2=. if general==0

* Standardization notes

/* Grade 9 score */
egen grade9_fra=rsum(brevfra1 brevfra2)
egen grade9_mat=rsum(brevmat1 brevmat2)

replace grade9_fra=. if general==0
replace grade9_mat=. if general==0

	foreach i of varlist mathel franel brevfra1 brevmat1 brevfra2 brevmat2 grade9_fra grade9_mat  {
        sum `i'	/*if repet!=2 */
		scalar esp=r(mean)
        corr `i',cov
        scalar var=r(Var_1)^0.5

        gen `i'_std = 50 + (10/var)*(`i'-esp)		
	}
	


sum mathel_std franel_std brevfra1_std brevmat1_std brevfra2_std brevmat2_std grade9_fra_std grade9_mat_std,noempty
sutex mathel_std franel_std brevfra1_std brevmat1_std brevfra2_std brevmat2_std grade9_fra_std grade9_mat_std

label var mathel_std "Initial Math score"
label var franel_std "Initial French score"
label var grade9_fra_std "Final French score"
label var grade9_mat_std "Final Math score"

/* Nb d'enfants */
gen nbenf1= (nbenf==1)
gen nbenf2= (nbenf==2)
gen nbenf3= (nbenf==3)
gen nbenf4etplus= (nbenf>=4) & (nbenf<99) 

label var nbenf1 "One child family"
label var nbenf2 "Two children family"
label var nbenf3 "Three children family"
label var nbenf4 "More than three children family"

/* Rang de la fratrie */
gen rang1= (rang==1)
gen rang2= (rang==2)
gen rang3= (rang==3)
gen rang4etplus= (rang>=4) & (rang<99) 

label var rang1 "First born"
label var rang2 "Second born"
label var rang3 "Third born"
label var rang4etplus "More than the fourth born"

/*Trimestre de naissance*/
gen quarter=1 if (monthbirth==1)|(monthbirth==2)|(monthbirth==3)
replace quarter=2 if (monthbirth==4)|(monthbirth==5)|(monthbirth==6)
replace quarter=3 if (monthbirth==7)|(monthbirth==8)|(monthbirth==9)
replace quarter=4 if (monthbirth==10)|(monthbirth==11)|(monthbirth==12)

tab quarter, gen(quarter_cat)

/*diplme pre et mre */
gen dipm=0
replace dipm=1 if a16m=="1" | a16m=="2" | a16m=="3" /* BEPC ou pas de diplme*/
replace dipm=2 if a16m=="4" | a16m=="5" /* BEP, CAP */
replace dipm=3 if a16m=="6" | a16m=="7" /* BAC gnral, tech et pro */
replace dipm=4 if a16m=="8" /* 1er cycle */
replace dipm=5 if a16m=="9"  /* 2me et 3me cycle */

gen dipp=0
replace dipp=1 if a16p=="1" | a16p=="2" | a16m=="3" /* BEPC ou pas de diplme*/
replace dipp=2 if a16p=="4" | a16p=="5" /* BEP, CAP */
replace dipp=3 if a16p=="6" | a16p=="7" /* BAC gnral, tech et pro */
replace dipp=4 if a16p=="8" /* 1er cycle */
replace dipp=5 if a16p=="9"  /* 2me et 3me cycle */

/*CSP */
gen cspp=substr(pcspere,1,1)
gen cspm=substr(pcsmere,1,1)

tab dipm,gen(dipm)
tab dipp,gen(dipp)
tab cspm,gen(cspm)
tab cspp,gen(cspp)

label var dipm1 "No education"
label var dipm2 "BEPC ou pas de diplme"
label var dipm3 "BEP, CAP"
label var dipm4 "BAC gnral, tech et pro"
label var dipm5 "1er cycle"
label var dipm6 "2me et 3me cycle"

label var cspp1 "Agriculteurs exploitants "
label var cspp2 "Chef d'entreprise, artisans, commerants"
label var cspp3 "Cadres, profession intellectuelles suprieures"
label var cspp4 "Profession intermdiaire"
label var cspp5 "Employ"
label var cspp6 "Ouvrier"
label var cspp7 "Inactif"


/*
1 : agriculteur
2 :Chefs d'entreprises, artisans, commerants,
3: cadres
4: prof. intellec. sup.
5 : employs
6 : ouvriers
8 : inactifs
*/

gen pere_et=(a19p=="3")
gen mere_et=(a19m=="3")

label var pere_et "Pre n  l'tranger"
label var mere_et "Mre ne  l'tranger"

* voie11234 voie12234 voie12334 voie1234 voie1V voie11V voie12V voie122V voie112V voie1123V voie1223V voie123V voie1233V
gen pass1=1
replace pass1=0 if voie11234 | voie1V |voie11V |voie112V | voie1123V

gen pass2=2
replace pass2=1 if voie12234 | voie122V | voie1223V
replace pass2=0 if voie11V | voie12V
replace pass2=. if voie1V

gen pass3=2
replace pass3=1 if voie12334 | voie1233V
replace pass3=0 if voie123V | voie122V |voie112V
replace pass3=. if voie1V | voie11V | voie12V

gen pass4=1
replace pass4=0 if voie1123V | voie1223V |voie1233V
replace pass4=. if voie1V | voie11V | voie12V | voie123V | voie122V |voie112V | voie1234

gen femme=(sexe=="1")
gen prim_priv=(b7=="2" | b7=="3")
gen redoub_prim= (cp!="1") | (ce1!="1") | (ce2!="1") | (cm1!="1") | (cm2!="1") 

label var femme "Female"
label var prim_priv "Primary school in private sector"
label var redoub_prim "Retention in primary school"

/*Time varying variables */

foreach n in 1 2 3 4 5 {
    
	gen net`n'_tr=0
    replace net`n'_tr=1 if net`n' <6 & net`n'>0
    replace net`n'_tr=2 if net`n' <11 & net`n'>5
    replace net`n'_tr=3 if net`n' >10

	tab net`n'_tr,gen(net`n'_tr)
	
	label var net`n'_tr1 "No foreign students in class"	
	label var net`n'_tr2 "1 to 5 foreign students in class" 
	label var net`n'_tr3 "6 to 10 foreign students in class" 
	label var net`n'_tr4 "More than 10 foreign students in class" 
	
	gen lv1`n'_all=(lv1`n'=="1")
    gen lv1`n'_ang=(lv1`n'=="2")
    gen lv1`n'_othe=(lv1`n'!="2" & lv1`n'!="1")
	
	label var lv1`n'_all "German"
	label var lv1`n'_othe "other"
	
	gen inzep`n'=(zep`n'=="1")
	label var inzep`n' "Subsidized school (ZEP)"
	
    gen secteur`n'b=(secteur`n'=="2")
	drop secteur`n'
	rename secteur`n'b secteur`n'
	label var secteur`n' "Private sector"
}	

save panel95b,replace

replace etab3=etab2 if pass2==0
replace etab4=etab2 if pass2==0 
replace etab5=etab2 if pass2==0

replace etab4=etab3 if pass3==0 
replace etab5=etab3 if pass3==0

replace etab5=etab3 if pass4==0

save panel95b,replace

* Use the data etab.dta

use etab,replace

* Construction of the instrumental variable : the maimonides'rule

	foreach i of varlist effectif6_9596 /*effectif5_9596 effectif4_9596 effectif3_9596 effectif3_9697 /*
	*/ effectif4_9697 */ effectif5_9697 effectif6_9697 /*effectif6_9798*/ effectif5_9798 effectif4_9798 /*effectif3_9798*/ /*
	*/ effectif3_9899 effectif4_9899 /*effectif5_9899 effectif6_9899 effectif6_9900 effectif5_9900 effectif4_9900 */  effectif3_9900 {				
		gen `i'class_th= `i'/ (round((`i'-1)/25)+1)			
	}
	

scatter effectif6_9596class_th effectif6_9596 

keep  eff_etab_t1  eff_etab_t2  eff_etab_t3  eff_etab_t4  eff_etab_t5 etab effectif6_9596 /*
*/ effectif5_9697 effectif6_9697 effectif5_9798 effectif4_9798 effectif3_9899 effectif4_9899 /*
*/ effectif3_9900 effectif3_9900class_th effectif4_9899class_th effectif3_9899class_th /*
*/ effectif4_9798class_th effectif5_9798class_th  /*
*/ effectif6_9697class_th effectif5_9697class_th effectif6_9596class_th


save etabb,replace

               use etabb, clear
			   rename etab etab1
			   sort etab1
			   save temp, replace
			   
			   use panel95b, clear
			   sort etab1
			   merge m:1 etab1 using "temp", keepusing(effectif6_9596class_th eff_etab_t1 effectif6_9596)
			   tab _merge 
			   keep if _merge==3
			   drop _merge
			   rename effectif6_9596class_th ned1_th
               rename effectif6_9596 effectif_grade_1
			   
save panel95d,replace

               use etabb, clear
			   rename etab etab2
			   sort etab2
			   save temp, replace
			   
			   use panel95d, clear
			   sort etab2
			   merge m:1 etab2 using "temp", keepusing(effectif6_9697class_th effectif5_9697class_th eff_etab_t2 effectif6_9697 effectif5_9697)
			   keep if _merge==3 | _merge==1
			   drop _merge
			   gen ned2_th=effectif6_9697class_th if substr(clas2,1,1)=="6"
			   replace ned2_th=effectif5_9697class_th if substr(clas2,1,1)=="5"
			   
			   gen effectif_grade_2=effectif6_9697 if substr(clas2,1,1)=="6"
			   replace effectif_grade_2=effectif5_9697 if substr(clas2,1,1)=="5"
			   
			   *Contrefactuels
			   gen ned2_th_c=effectif6_9697class_th if substr(clas2,1,1)=="5"
			   replace ned2_th_c=effectif5_9697class_th if substr(clas2,1,1)=="6"
			   
save panel95d,replace

               use etabb, clear
			   rename etab etab3
			   sort etab3
			   save temp, replace
			   
			   use panel95d, clear
			   sort etab3
			   merge m:1 etab3 using "temp", keepusing(effectif4_9798class_th effectif5_9798class_th eff_etab_t3 effectif5_9798 effectif4_9798)
			   tab _merge 
			   keep if _merge==3 | _merge==1
			   drop _merge
			   gen ned3_th=effectif5_9798class_th if substr(clas3,1,1)=="5"
			   replace ned3_th=effectif4_9798class_th if substr(clas3,1,1)=="4"
			   
			   gen effectif_grade_3=effectif5_9798 if substr(clas3,1,1)=="5"
			   replace effectif_grade_3=effectif4_9798 if substr(clas3,1,1)=="4"
			   
			   *Contrefactuels
			   gen ned3_th_c=effectif5_9798class_th if substr(clas3,1,1)=="4" | substr(clas3,1,1)=="7"
			   gen ned3_th_cr=effectif4_9798class_th if substr(clas3,1,1)=="5" | substr(clas3,1,1)=="7"
			   
			   gen eff_etab_t3_c=eff_etab_t3 if substr(clas3,1,1)=="7"
		   
			   
save panel95d,replace

               use etabb, clear
			   rename etab etab4
			   sort etab4
			   save temp, replace
			   
			   use panel95d, clear
			   sort etab4
			   merge m:1 etab4 using "temp", keepusing(effectif4_9899class_th effectif3_9899class_th effectif3_9900class_th effectif3_9900 eff_etab_t4 effectif3_9899 effectif4_9899 eff_etab_t5)
			   tab _merge 
			   keep if _merge==3 |_merge==1
			   drop _merge
			   gen ned4_th=effectif3_9899class_th if substr(clas4,1,1)=="3"
			   replace ned4_th=effectif4_9899class_th if substr(clas4,1,1)=="4"
			   
			   gen effectif_grade_4=effectif3_9899 if substr(clas4,1,1)=="3"
			   replace effectif_grade_4=effectif4_9899 if substr(clas4,1,1)=="4"
			   
			   *Contrefactuels
			   gen ned4_th_c=effectif4_9899class_th if substr(clas4,1,1)=="3" | substr(clas4,1,1)=="7"
			   gen ned4_th_cr=effectif3_9899class_th if substr(clas4,1,1)=="4" | substr(clas4,1,1)=="7"
			   
			   gen effectif_grade_4_c=effectif4_9899 if substr(clas4,1,1)=="3"
			   replace effectif_grade_4_c=effectif3_9899 if substr(clas4,1,1)=="4" | substr(clas4,1,1)=="7"
			   
			   *gen eff_etab_t5_c=eff_etab_t5 if substr(clas4,1,1)=="3" ?
			   gen ned5_th_c=effectif3_9900class_th if substr(clas4,1,1)=="3" | substr(clas4,1,1)=="7"
			   gen effectif_grade_5_c=effectif3_9900 if substr(clas4,1,1)=="3" | substr(clas4,1,1)=="7"
			   
			   gen eff_etab_t4_c=eff_etab_t4 if substr(clas4,1,1)=="7"

   
save panel95d,replace

               use etabb, clear
			   rename etab etab5
			   sort etab5
			   save temp, replace
			   
			   use panel95d, clear
			   sort etab5
			   merge m:1 etab5 using "temp", keepusing(effectif3_9900class_th eff_etab_t5 effectif3_9900)
			   tab _merge 
			   drop _merge
			   drop if ident ==""
			   gen ned5_th=effectif3_9900class_th if substr(clas5,1,1)=="3"
			   
			   gen ned5_th_cr=effectif3_9900class_th if substr(clas4,1,1)=="7"
			   
			   gen effectif_grade_5=effectif3_9900 if substr(clas5,1,1)=="3"
			   
			   gen eff_etab_t5_c=eff_etab_t5 if substr(clas4,1,1)=="7" 
			   
			   gen effectif_grade_5_cr=effectif3_9900 if substr(clas4,1,1)=="7"
			   
  
save panel95d,replace

drop  effectif3_9900class_th effectif4_9899class_th effectif3_9899class_th effectif4_9798class_th effectif5_9798class_th /*
*/ effectif6_9697class_th effectif5_9697class_th

foreach n in 1 2 3 4 5 {

label var ned`n'_th "Theoretical class size"
label var ned`n' "Class size"
label var effectif_grade_`n' " Total grade enrollment"
label var eff_etab_t`n' "Total school enrollment"

tab tuetab`n',gen(tuetab`n')
label var tuetab`n'1 "Rural area"
label var tuetab`n'2 "Less than 5,000 habitants"
label var tuetab`n'3 "5,000 to 9,999 habitants"
label var tuetab`n'4 "10,000 to 19,999 habitants"
label var tuetab`n'5 "20,000 to 49,999 habitants"
label var tuetab`n'6 "50,000 to 99,999 habitants"
label var tuetab`n'7 "100,000 to 199,999 habitants"
label var tuetab`n'8 "200,000 to 1,999,9999 habitants"
label var tuetab`n'9 "Paris "

}

save panel95c,replace


* Maintenant on ne garde que les non rorients

keep if general==1

replace pass2=pass2-1
replace pass3=pass3-1


gen diff_fr= grade9_fra_std-franel_std 
gen diff_mat= grade9_mat_std-mathel_std

sum mathel_std franel_std grade9_fra_std grade9_mat_std diff_fr diff_mat,noempty
sutex mathel_std franel_std grade9_fra_std grade9_mat_std diff_fr diff_mat

*Les filles en 6me sont meilleures en math mais bien moins fortes en franais 
*En troisime, elles restent bien moins fortes en franais et sont un tout petit peu moins fortes en math.....
bysort femme : sum grade9_fra_std

bysort repet : sum mathel_std franel_std grade9_fra_std grade9_mat_std diff_fr diff_mat,noempty
bysort repet : sutex mathel_std franel_std grade9_fra_std grade9_mat_std diff_fr diff_mat

bysort monthbirth : sum mathel_std franel_std grade9_fra grade9_mat diff_fr diff_mat,noempty
bysort repet monthbirth : sum mathel_std franel_std grade9_fra grade9_mat diff_fr diff_mat,noempty

graph box mathel_std,over(quarter) over(repet)
graph box diff_fr,over(quarter) over(repet)
graph box diff_mat,over(quarter) over(repet)

foreach var in repet mathel_std franel_std grade9_fra_std grade9_mat_std diff_fr diff_mat {
egen mean_`var'=mean(`var'), by(quarter)
egen mean_`var'_2=mean(`var'), by(quarter repet)
}

label var mean_repet "Retention probability"
label var quarter "Quarter of birth"
label var mean_diff_mat "Math Value Added"
label var mean_diff_fr "Language Value Added"
label var mean_mathel_std "Math grade 6"
label var mean_franel_std "Language grade 6"
label var mean_grade9_mat_std "Math grade 9"
label var mean_grade9_fra_std "Language grade 9"

label var mean_diff_mat_2 "Math Value Added"
label var mean_diff_fr_2 "Language Value Added"
label var mean_mathel_std_2 "Math grade 6"
label var mean_franel_std_2 "Language grade 6"
label var mean_grade9_mat_std_2 "Math grade 9"
label var mean_grade9_fra_std_2 "Language grade 9"

twoway line mean_repet quarter, lwidth(thick) 

line mean_mathel_std mean_grade9_mat_std mean_franel_std mean_grade9_fra_std  quarter,  lwidth(medthin thick medthin thick ) lpattern(solid solid dash dash)

line mean_diff_mat  mean_diff_fr   quarter,  lpattern(solid dash) lwidth(thick thick)

line mean_mathel_std_2 mean_grade9_mat_std_2 mean_franel_std_2 mean_grade9_fra_std_2  quarter if repet==1 || line mean_mathel_std_2 mean_grade9_mat_std_2 mean_franel_std_2 mean_grade9_fra_std_2  quarter if repet==0

line mean_diff_mat_2  mean_diff_fr_2  quarter if repet==1, lwidth(thick thick ) lpattern(solid dash)   || line mean_diff_mat_2  mean_diff_fr_2  quarter if repet==0, lwidth(medthinmedthin ) lpattern(solid dash) /*
*/legend(lab(1 "French Value Added repeaters") lab(2 "Math Value Added repeaters") lab(3 "French Value Added non-repeaters") lab(4 "Math Value Added non-repeaters") textwidth(150) )

/* First stage*/

*xi: reg repet i.quarter mathel_std i.sexe i.pcsmere i.pcspere i.a16m i.a16p nbenf2 nbenf3 nbenf4etplus rang2 rang3 rang4etplus age6e i.a6 i.a19m i.a19p redoub_prim i.b7

gen semester=(quarter==1 |quarter==2)
* a little bit proper
char quarter[omit] 4
char semester[omit] 2
char cspm[omit] 5
char cspp[omit] 5
char dipm[omit] 1
xi: reg repet i.quarter  femme i.dipp i.cspm redoub_prim pere_et nbenf3 nbenf4etplus rang4etplus eff_etab_t1 
outreg2 using first_stage,tex(fragment) replace

/*OLS and IV */

xi : reg mathel_std femme i.dipm i.cspp mere_et pere_et redoub_prim nbenf4etplus 
xi : reg franel_std femme i.dipm i.cspp mere_et pere_et redoub_prim nbenf4etplus 

xi : reg diff_fr repet    femme i.dipm i.cspp mere_et pere_et  nbenf4etplus eff_etab_t1 
est store olsfr
xi : ivreg diff_fr (repet=i.quarter) femme i.dipm i.cspp mere_et pere_et  nbenf4etplus eff_etab_t1 
est store ivfr
xi : reg diff_mat repet  femme i.dipm i.cspp mere_et pere_et  nbenf4etplus eff_etab_t1 
est store olsmat
xi : ivreg diff_mat (repet=i.quarter ) femme i.dipm i.cspp mere_et pere_et nbenf4etplus eff_etab_t1 
est store ivmat
outreg2 [olsmat olsfr ivmat ivfr] using 2SLS,tex(fragment) label replace 

xi : reg grade9_fra_std repet  mathel_std franel_std  femme i.dipm i.cspp mere_et pere_et  nbenf4etplus eff_etab_t1 
est store olsfr
xi : ivreg grade9_fra_std (repet=i.quarter) mathel_std franel_std  femme i.dipm i.cspp mere_et pere_et  nbenf4etplus eff_etab_t1 
est store ivfr
xi : reg grade9_mat_std repet  mathel_std franel_std femme i.dipm i.cspp mere_et pere_et  nbenf4etplus eff_etab_t1 
est store olsmat
xi : ivreg grade9_mat_std (repet=i.quarter) mathel_std franel_std femme i.dipm i.cspp mere_et pere_et  nbenf4etplus eff_etab_t1 
est store ivmat
outreg2 [olsmat olsfr ivmat ivfr] using 2SLS_2,tex(fragment) label replace 



/* 3SLS */

*xi : reg3 (diff_fr repet franel_std i.sexe i.pcsmere i.pcspere rang3 rang4etplus redoub_prim  i.a16m  i.b7) /*
**/ (repet i.quarter franel_std i.sexe rang3 rang4etplus redoub_prim i.pcsmere i.pcspere i.a16m  i.b7)
*outreg2 using 3sls1,tex(fragment) replace 



/*********************************/
/*** Endogeneity of class size ***/
/*********************************/


xi : reg ned1 ned1_th 
est store inst1
xi : reg ned2 ned2_th 
est store inst2
xi : reg ned3 ned3_th 
est store inst3
xi : reg ned4 ned4_th 
est store inst4
xi : reg ned5 ned5_th 
est store inst5
outreg2 [inst1 inst2 inst3 inst4 inst5 ] using instruments,tex(fragment) keep(ned1_th ned2_th ned3_th ned4_th ned5_th)  replace 

xi : reg ned3 ned3_th i.tuetab3 effectif_grade_3 
outreg2 using class3,tex(fragment) replace 
xi : reg ned4 ned4_th i.tuetab4 effectif_grade_4 
outreg2 using class4,tex(fragment) replace 
xi : reg ned5 ned5_th i.tuetab5 effectif_grade_5 eff_etab_t5
outreg2 using class5,tex(fragment) replace 


* 1ere anne

xi : reg pass1 ned1 mathel_std franel_std femme i.dipm i.cspp pere_et i.net1_tr effectif_grade_1 
est store ols
xi : ivreg pass1 (ned1=ned1_th ) mathel_std franel_std femme i.dipm i.cspp pere_et i.net1_tr effectif_grade_1
est store iv
outreg2 [ols iv] using pass1,tex(fragment) replace 

* 2me anne

xi : reg pass2 ned2 franel_std mathel_std femme i.dipm i.cspp redoub_prim effectif_grade_2 
est store ols
xi : ivreg pass2 (ned2=ned2_th) franel_std mathel_std femme  i.dipm i.cspp redoub_prim  effectif_grade_2 
est store iv
outreg2 [ols iv] using pass2,tex(fragment) replace 

* 3me anne

xi : reg pass3 ned3 mathel_std franel_std femme i.dipm i.cspp redoub_prim nbenf2 nbenf3 nbenf4etplus  i.net3_tr 
est store ols
xi : ivreg pass3 (ned3=ned3_th i.tuetab3 effectif_grade_3) mathel_std franel_std femme i.dipm i.cspp redoub_prim nbenf2 nbenf3 nbenf4etplus  i.net3_tr 
est store iv
outreg2 [ols iv] using pass3,tex(fragment) replace 

*4eme anne * sparer le cas redoublants et non redoublants pour voir l'impact de la taille des classes sur ces diffrents groupes.

* French
xi : reg grade9_fra_std ned5 mathel_std franel_std femme i.dipm i.cspp redoub_prim nbenf2 nbenf3 nbenf4etplus i.net5_tr if repet
est store ols
xi : ivreg grade9_fra_std (ned5=ned5_th i.tuetab5 effectif_grade_5 ) mathel_std franel_std femme /*
*/ i.dipm i.cspp redoub_prim nbenf2 nbenf3 nbenf4etplus i.net5_tr if repet
est store iv
outreg2 [ols iv] using grade9_fra_repet,tex(fragment) replace 

xi : reg grade9_fra_std ned4 mathel_std franel_std femme i.dipm i.cspp redoub_prim nbenf2 nbenf3 nbenf4etplus i.net4_tr if repet==0
est store ols
xi : ivreg grade9_fra_std (ned4=ned4_th i.tuetab4 effectif_grade_4 ) mathel_std franel_std femme /*
*/ i.dipm i.cspp redoub_prim nbenf2 nbenf3 nbenf4etplus i.net4_tr if repet==0
est store iv
outreg2 [ols iv] using grade9_fra_nonrepet,tex(fragment) replace 

*Math
xi : reg grade9_mat_std ned5 mathel_std franel_std femme i.dipm i.cspp redoub_prim nbenf2 nbenf3 nbenf4etplus i.net5_tr if repet
est store ols
xi : ivreg grade9_mat_std (ned5=ned5_th i.tuetab5 effectif_grade_5 ) mathel_std franel_std femme /*
*/ i.dipm i.cspp redoub_prim nbenf2 nbenf3 nbenf4etplus i.net5_tr if repet
est store iv
outreg2 [ols iv] using grade9_mat_repet,tex(fragment) replace 

xi : reg grade9_mat_std ned4 mathel_std franel_std femme i.dipm i.cspp redoub_prim nbenf2 nbenf3 nbenf4etplus i.net4_tr if repet==0
est store ols
xi : ivreg grade9_mat_std (ned4=ned4_th i.tuetab4 effectif_grade_4 ) mathel_std franel_std femme /*
*/ i.dipm i.cspp redoub_prim nbenf2 nbenf3 nbenf4etplus i.net4_tr if repet==0
est store iv
outreg2 [ols iv] using grade9_mat_nonrepet,tex(fragment) replace 



