clear all

cd "C:\Users\MAGOU238\Dropbox\Redoublement"

sysdir set PERSONAL "C:\Users\MAGOU238\Dropbox\Redoublement\ado\personal"
sysdir set PLUS "C:\Users\MAGOU238\Dropbox\Redoublement\ado\plus"
set mem 800m

use panel95c ,replace

set more off

keep ident mathel_std franel_std femme dipm dipm1-dipm6 cspp cspp1-cspp7 age6e rang2 rang3 rang4etplus nbenf3 nbenf4etplus /*
*/ mere_et pere_et prim_priv pass1 pass2 pass3 pass4 general grade9_fra_std grade9_mat_std redoub_prim repet /*
*/ ned1 ned1_th tuetab1 tuetab11-tuetab19 secteur1 net1_tr net1_tr1-net1_tr4 effectif_grade_1 eff_etab_t1 lv11_all lv11_ang lv11_othe  inzep1  /*
*/ ned2 ned2_th ned2_th_c tuetab2 tuetab21-tuetab29  secteur2 net2_tr net2_tr1-net2_tr4 effectif_grade_2 eff_etab_t2 lv12_all lv12_ang lv12_othe  inzep2   /*
*/ ned3 ned3_th ned3_th_c ned3_th_cr tuetab3 tuetab31-tuetab39  secteur3 net3_tr net3_tr1-net3_tr4 effectif_grade_3 eff_etab_t3_c eff_etab_t3 lv13_all lv13_ang lv13_othe  inzep3  /*
*/ ned4 ned4_th ned4_th_c ned4_th_cr tuetab4 tuetab41-tuetab49 secteur4 net4_tr net4_tr1-net4_tr4 effectif_grade_4 effectif_grade_4_c eff_etab_t4 eff_etab_t4_c lv14_all lv14_ang lv14_othe  inzep4  /*
*/ ned5 ned5_th ned5_th_c ned5_th_cr tuetab5 tuetab51-tuetab59 secteur5 net5_tr net5_tr1-net5_tr4 effectif_grade_5 effectif_grade_5_c eff_etab_t5 eff_etab_t5_c lv15_all lv15_ang lv15_othe  inzep5  /*
*/ voie1234 voie11234 voie12234 voie12334 voie123V voie12V voie11V voie122V voie1233V voie1223V voie1123V voie112V quarter

foreach i of varlist mathel_std franel_std  /*
*/ ned1 ned1_th tuetab1 secteur1 net1_tr eff_etab_t1 lv11_all lv11_othe inzep1 {

drop if missing(`i')
}

foreach i of varlist /*
*/ ned2 ned2_th tuetab2 secteur2 net2_tr eff_etab_t2 lv12_all lv12_othe inzep2  /*
*/ ned3 ned3_th tuetab3 secteur3 net3_tr eff_etab_t3 lv13_all lv13_othe inzep3  /*
*/ ned4 ned4_th tuetab4 secteur4 net4_tr eff_etab_t4 lv14_all lv14_othe inzep4  {

drop if missing(`i') & repet<2
}

foreach i of varlist voie1234 voie11234 voie12234 voie12334 voie123V voie12V voie11V voie122V voie1233V voie1223V voie1123V voie112V {
tab `i'
}

save BDD_2012,replace

recode grade9_fra_std .=-1
recode grade9_mat_std .=-1
recode pass3 .=-1
recode pass4 .=-1
recode effectif_grade_5 .=0
recode eff_etab_t5 .=0
recode effectif_grade_4 .=0
recode eff_etab_t4 .=0

replace pass3=. if pass3==-1
replace pass4=. if pass4==-1


/*
******************************
***** Separate Equations *****
******************************

reg ned5 ned5_th dipm5 dipm6 eff_etab_t5 tuetab52 tuetab55-tuetab59 lv15_all inzep5 if repet==1
gen n5contrefact=_b[_cons]+_b[dipm5]*dipm5+_b[dipm6]*dipm6+_b[ned5_th]*ned5_th_c+_b[eff_etab_t5]*eff_etab_t4 +_b[tuetab52]*(tuetab4=="1")+_b[tuetab55]*(tuetab4=="4")+_b[tuetab56]*(tuetab4=="5")+_b[tuetab57]*(tuetab4=="6") /*
*/+_b[tuetab58]*(tuetab4=="7")+_b[tuetab59]*(tuetab4=="8")+_b[lv15_all]*lv14_all +_b[inzep5]*inzep4 if repet==0

reg ned4 ned4_th femme dipm4-dipm6 cspp2-cspp4 nbenf4etplus redoub_prim secteur4 eff_etab_t4 tuetab42-tuetab49 net4_tr3 lv14_all inzep4  if repet==0
predict n4contrefact if repet==1
replace n4contrefact=n4contrefact+_b[ned4_th]*(ned4_th_cr-ned4_th)  if repet==1

reg grade9_fra_std ned5 femme dipm3-dipm6 redoub_prim pere_et prim_priv secteur5 net5_tr2 if repet==1
gen grade9f_ifpasspas =_b[_cons]+_b[ned5]*n5contrefact+_b[femme]*femme+_b[dipm3]*dipm3+_b[dipm4]*dipm4+_b[dipm5]*dipm5+_b[dipm6]*dipm6+_b[redoub_prim]*redoub_prim+_b[pere_et]*pere_et+_b[prim_priv]*prim_priv/*
*/+_b[secteur5]*(secteur4==1)+_b[net5_tr2]*net5_tr2  if repet==0

reg grade9_mat_std ned5 femme dipm5-dipm6 redoub_prim secteur5 tuetab56 tuetab57 tuetab59 if repet==1
gen grade9m_ifpasspas =_b[_cons]+_b[ned5]*n5contrefact+_b[femme]*femme+_b[dipm5]*dipm5+_b[dipm6]*dipm6+_b[redoub_prim]*redoub_prim+_b[secteur5]*(secteur4==1)+_b[tuetab56]*(tuetab4=="5")+_b[tuetab57]*(tuetab4=="6")+_b[tuetab59]*(tuetab4=="8") if repet==0

reg grade9_fra_std ned4 femme dipm3-dipm6 cspp2-cspp7 nbenf4etplus redoub_prim eff_etab_t4 tuetab48-tuetab49 net4_tr2-net4_tr3 lv14_all inzep4 if repet==0
predict grade9f_ifpass if repet==1
replace grade9f_ifpass=grade9f_ifpass+_b[ned4]*(n4contrefact-ned4) if repet==1

reg grade9_mat_std ned4 femme dipm2-dipm6 cspp2-cspp7 nbenf4etplus redoub_prim secteur4 eff_etab_t4 tuetab42-tuetab49 lv14_all  if repet==0
predict grade9m_ifpass if repet==1
replace grade9m_ifpass=grade9m_ifpass+_b[ned4]*(n4contrefact-ned4) if repet==1

* Effects 

gen Effectm=(grade9m_ifpasspas-grade9_mat_std) if repet==0
replace Effectm=(grade9_mat_std-grade9m_ifpass) if repet==1

gen Effectf=(grade9f_ifpasspas-grade9_fra_std) if repet==0
replace Effectf=(grade9_fra_std-grade9f_ifpass) if repet==1

sum Effectm Effectf 
sum Effectm Effectf if repet==1

*/

******************************
***** System of Equations *****
******************************

gen grade9_classize= ned4 if repet==0
replace grade9_classize=ned5 if repet==1

gen grade9_classize_th= ned4_th if repet==0
replace grade9_classize_th=ned5_th if repet==1

gen redoubl=(repet==1)
replace redoubl=. if repet==2

replace grade9_fra_std=. if repet==2
replace grade9_mat_std=. if repet==2
gen semester=(quarter>2)

global X "femme dipm2-dipm6 cspp1-cspp5 cspp7 nbenf3 nbenf4etplus redoub_prim pere_et mere_et prim_priv"
global Y6 "mathel_std franel_std"
global X9 "tuetab42-tuetab49 net4_tr2-net4_tr4 inzep4"
global X1 "tuetab12-tuetab19 net1_tr2-net1_tr4 inzep1"

reg3 (Ym: grade9_mat_std $X $Y6 grade9_classize redoubl $X9 ) (Yf: grade9_fra_std $X $Y6 grade9_classize redoubl $X9 ) (N: grade9_classize $X $Y6 grade9_classize_th redoubl eff_etab_t4  $X9 ) (R: redoubl $Y6 ned1 semester $X $X1 ) /*(Y0m: mathel_std $X ) (Y0f: franel_std $X )*/ (N0: ned1 $X $Y6 ned1_th eff_etab_t1 $X1 ) , 3sls


global X "femme dipm2-dipm6 cspp1-cspp5 cspp7 nbenf3 nbenf4etplus redoub_prim pere_et mere_et prim_priv  "
global Y6 "mathel_std franel_std"
global X9 ""
global X1 ""

reg3 (Ym: grade9_mat_std $X $Y6 grade9_classize redoubl $X9 ) (Yf: grade9_fra_std $X $Y6 grade9_classize redoubl $X9) (N: grade9_classize $X $Y6 grade9_classize_th redoubl eff_etab_t4  $X9 ) (R: redoubl $Y6 ned1 $X $X1 semester )  (N0: ned1 $X $Y6 ned1_th eff_etab_t1  $X1 ) , 3sls


outreg2 using Reg3,tex(fragment)  label  replace

matrix list e(Sigma)

*predict Ym_c, equation(Ym)

*Counterfactuals

gen n5contrefact=ned5+[N]_b[redoubl] if repet==0
gen n4contrefact=ned5-[N]_b[redoubl] if repet==1
gen grade9f_ifpasspas=grade9_fra_std+[Yf]_b[grade9_classize]*(n5contrefact-grade9_classize)+[Yf]_b[redoubl] if repet==0
gen grade9m_ifpasspas=grade9_mat_std+[Ym]_b[grade9_classize]*(n5contrefact-grade9_classize)+[Ym]_b[redoubl] if repet==0
gen grade9f_ifpass=grade9_fra_std+[Yf]_b[grade9_classize]*(n4contrefact-grade9_classize)-[Yf]_b[redoubl]  if repet==1
gen grade9m_ifpass=grade9_mat_std+[Ym]_b[grade9_classize]*(n4contrefact-grade9_classize)-[Ym]_b[redoubl] if repet==1

* Effects 

gen Effectm=(grade9m_ifpasspas-grade9_mat_std) if repet==0
replace Effectm=(grade9_mat_std-grade9m_ifpass) if repet==1

gen Effectf=(grade9f_ifpasspas-grade9_fra_std) if repet==0
replace Effectf=(grade9_fra_std-grade9f_ifpass) if repet==1

sum Effectm Effectf 
sum Effectm Effectf if repet==1


******************************
***** Value Added *****
******************************

gen diff_fr= grade9_fra_std-franel_std 
gen diff_mat= grade9_mat_std-mathel_std

global X "femme dipm2-dipm6 cspp2-cspp7 nbenf3 nbenf4etplus redoub_prim pere_et mere_et prim_priv"
global Y6 "mathel_std franel_std"
global X9 "eff_etab_t4 tuetab42-tuetab49 net4_tr2-net4_tr4 inzep4"
global X1 "eff_etab_t1 tuetab12-tuetab19 net1_tr2-net1_tr4 inzep1"

reg3 (Ym: diff_mat $X $Y6 grade9_classize redoubl) (Yf: diff_fr $X $Y6 grade9_classize redoubl) (N: grade9_classize $X $Y6 grade9_classize_th redoubl $X9 ) (R: redoubl $Y6 ned1 semester $X $X1 ) (N0: ned1 $X $Y6 ned1_th $X1) , 3sls

outreg2 using Reg4,tex(fragment)  label  replace


reg3 (Ym: diff_mat $X grade9_classize redoubl) (Yf: diff_fr $X grade9_classize redoubl) (N: grade9_classize $X grade9_classize_th redoubl $X9 ) (R: redoubl ned1 semester $X $X1 ) (N0: ned1 $X ned1_th $X1) , 3sls

outreg2 using Reg5,tex(fragment)  label  replace

